Package: groovy.jmx.builder

## [Groovy] Class JmxMetaMapBuilder

- groovy.jmx.builder.JmxMetaMapBuilder

-     class JmxMetaMapBuilder
      extends Object

  The JmxMetaMapBuilder class is used to collect meta data passed in JmxBuilder nodes. Once collected, the data is then normalized to be represented uniformly regardless of the resource where it was obtained.

- - ### Constructor Summary

    Constructors
    Constructor and description
    `JmxMetaMapBuilder()`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `static Map` | `buildAttributeMapFrom(Object object)` Builds attribute meta map with default information from an instance of an object.
    `` | `static Map` | `buildAttributeMapFrom(Object object, Object descCollection)` Sanitizes and builds an attribute meta map from a descriptor collection.
    `` | `static Map` | `buildConstructorMapFrom(Object object)` Returns a meta map of constructors from given object.
    `` | `static Map` | `buildConstructorMapFrom(Object object, Object descCollection)` Builds a fully normalized constructor meta map.
    `` | `static Object` | `buildListenerMapFrom(Object descCollection)` Creates a fully-normalized meta map for a given collection of listeners.
    `` | `static Map` | `buildObjectMapFrom(Object object)` Builds a complete meta map graph for the specified object using default values.
    `` | `static Map` | `buildObjectMapFrom(Object object, Object descriptor)` Builds a complete meta map graph for a given target and descriptor.
    `` | `static Map` | `buildOperationMapFrom(Object object)` Returns a meta map of operations from given object.
    `` | `static Map` | `buildOperationMapFrom(Object object, Object descCollection)` Builds an operation meta map from the supplied descriptor collection.
    `` | `static Map` | `buildParameterMapFrom(Object method)` Builds a normalized parameter meta map for all params on provided method.
    `` | `static Map` | `buildParameterMapFrom(Object method, Object descCollection)` Builds a fully normalized parameter meta map for the method and the given meta map.
    `` | `static Map` | `createListenerMap(Object descriptor)` Builds normalized meta map of the provided listener descriptor.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JmxMetaMapBuilder()

  - ### Method Detail

    - #### static Map buildAttributeMapFrom(Object object)

      Builds attribute meta map with default information from an instance of an object.

      Parameters:
        `the` - object from which attribute info will be retrieved
      Returns:
        the meta map for the attribute

    - #### static Map buildAttributeMapFrom(Object object, Object descCollection)

      Sanitizes and builds an attribute meta map from a descriptor collection. The collection can either be a map of the form [attribName:[descriptor...],...] or [attribName1,...attribNameN]. The code guests sensible defaults when values are not provided

      Parameters:
        `the` - object about which meta data is collected
        `descriptor` - collection: either a map or a list
      Returns:
        a Map of meta information about the object.

    - #### static Map buildConstructorMapFrom(Object object)

      Returns a meta map of constructors from given object.

      Parameters:
        `object` - to profile
      Returns:
        The meta map generated.

    - #### static Map buildConstructorMapFrom(Object object, Object descCollection)

      Builds a fully normalized constructor meta map.

      Parameters:
        `the` - object where constructor is defined.
        `the` - meta map that will be normalized
      Returns:
        a normalized meta map for the constructor

    - #### static Object buildListenerMapFrom(Object descCollection)

      Creates a fully-normalized meta map for a given collection of listeners.

      Parameters:
        `descCollection` - collection of descriptors to normalize
      Returns:
        the normalized listener metadata
      See Also:
        JmxMetaMapBuilder.createListenerMap

    - #### static Map buildObjectMapFrom(Object object)

      Builds a complete meta map graph for the specified object using default values. All generated attributes are set to read-only.

      Parameters:
        `object` - used to build meta data graph
      Returns:
        fully-realized meta map of the object
      See Also:
        buildAttributeMapFrom(Object)
        buildConstructorMapFrom(Object)
        buildOperationMapFrom(Object)

    - #### static Map buildObjectMapFrom(Object object, Object descriptor)

      Builds a complete meta map graph for a given target and descriptor.

      Parameters:
        `object` - used to build meta data graph
        `descriptor` - a full descriptor map describing object attributes and ops.
      Returns:
        fully-realized meta map of the object
      See Also:
        buildAttributeMapFrom(Object, Map)
        buildConstructorMapFrom(Object, Map)
        buildOperationMapFrom(Object, Map)

    - #### static Map buildOperationMapFrom(Object object)

      Returns a meta map of operations from given object.

      Parameters:
        `object` - to profile
      Returns:
        The meta map generated.

    - #### static Map buildOperationMapFrom(Object object, Object descCollection)

      Builds an operation meta map from the supplied descriptor collection.

      Parameters:
        `object` - the object being profiled
        `descCollection` - the operation descriptor collection
      Returns:
        the normalized operation metadata

    - #### static Map buildParameterMapFrom(Object method)

      Builds a normalized parameter meta map for all params on provided method.

      Parameters:
        `the` - method with parameters to normalized
      Returns:
        the normalized map

    - #### static Map buildParameterMapFrom(Object method, Object descCollection)

      Builds a fully normalized parameter meta map for the method and the given meta map.

      Parameters:
        `the` - method from which to extract normalized info.
        `a` - given meta map which will be normalized
      Returns:
        the normalized map

    - #### static Map createListenerMap(Object descriptor)

      Builds normalized meta map of the provided listener descriptor.

      Parameters:
        `descriptor` - - descriptive data collected from JmxBuilder listener nodes.
      Returns:
        - fully normalized meta map of listener data.